using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace PrintMultipleGrids
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private System.Windows.Forms.Button button1;
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl2;
		private System.Windows.Forms.Button button2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.button1 = new System.Windows.Forms.Button();
			this.gridControl2 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.button2 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridControl2)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.gridControl1.ColCount = 9;
			this.gridControl1.Location = new System.Drawing.Point(16, 32);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.RowCount = 60;
			this.gridControl1.Size = new System.Drawing.Size(360, 256);
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.button1.Location = new System.Drawing.Point(112, 304);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(128, 23);
			this.button1.TabIndex = 1;
			this.button1.Text = "Print Preview Left Only";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// gridControl2
			// 
			this.gridControl2.ColCount = 7;
			this.gridControl2.Location = new System.Drawing.Point(424, 40);
			this.gridControl2.Name = "gridControl2";
			this.gridControl2.RowCount = 60;
			this.gridControl2.Size = new System.Drawing.Size(304, 248);
			this.gridControl2.TabIndex = 2;
			this.gridControl2.Text = "gridControl2";
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(424, 304);
			this.button2.Name = "button2";
			this.button2.TabIndex = 3;
			this.button2.Text = "Print Both";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(760, 333);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button2,
																		  this.gridControl2,
																		  this.button1,
																		  this.gridControl1});
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridControl2)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
 
		private void button1_Click(object sender, System.EventArgs e)
		{
			
			//printpreview
			if (gridControl1 != null) 
			{ 
				try 
				{ 
					GridPrintAtLocDocument pd = new GridPrintAtLocDocument(gridControl1, true); //Assumes the default printer 
					PrintPreviewDialog dlg = new PrintPreviewDialog() ; 
					dlg.Document = pd; 
					dlg.ShowDialog(); 
				} 
				catch(Exception ex) 
				{ 
					MessageBox.Show("An error occurred attempting to preview - " + ex.Message); 
				} 
			} 
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			//printboth
			if (gridControl1 != null) 
			{ 
				try 
				{ 
					GridPrintAtLocDocument pd = new GridPrintAtLocDocument(gridControl1, true); //Assumes the default printer 
					PrintDialog dlg = new PrintDialog() ; 

					//comment out next two lines just to use default printer/setting with no dialog
					dlg.Document = pd; 
					if(dlg.ShowDialog() == DialogResult.OK)
					{
						pd.pageNo = 0;
						pd.Print(); //print first grid

						//print the next grid with same settings...
						GridPrintAtLocDocument pd1 = new GridPrintAtLocDocument(gridControl2, true);
						pd1.DefaultPageSettings = pd.DefaultPageSettings;
						pd1.pageNo = pd.pageNo;
						pd1.Print(); //print the second grid
					}
				} 
				catch(Exception ex) 
				{ 
					MessageBox.Show("An error occurred attempting to preview - " + ex.Message); 
				} 
			} 
		}
	}

	public class GridPrintAtLocDocument : GridPrintDocument
	{
		private GridControlBase _grid;
		
		private int headerHeight;
		
		private int footerHeight;

		public int pageNo;

		public GridPrintAtLocDocument(GridControlBase grid, bool printPreview)
			: base(grid, printPreview)
		{
			_grid = grid;

			headerHeight = 50;
			footerHeight = 20;

			int left = this.DefaultPageSettings.Margins.Left;
			int top = this.DefaultPageSettings.Bounds.Top + 2 * headerHeight; //doubling the height so it can be centered vertically
			int right = this.DefaultPageSettings.Margins.Right;
			int bottom = this.DefaultPageSettings.Margins.Bottom + 2 * footerHeight; //doubling the height so it can be centered vertically
			this.DefaultPageSettings.Margins =  new Margins(left, right, top, bottom);

			//pageNo = 1;
		}

		protected override void OnPrintPage(System.Drawing.Printing.PrintPageEventArgs ev)
		{
			string text = string.Format("{1} P{0}", pageNo, this._grid.Name);

			if(pageNo == 0)
			{
				text = "My Two Grids\r\n\r\nTitle Page";
				//don't call baseclass so no grid is printed on page 0
			}
			else
				base.OnPrintPage(ev);

			//define the header text and measure it
			
			Font font = new Font(_grid.Font.Name, 30);
			SizeF sz = ev.Graphics.MeasureString(text, font);


			//compute the position of the header
			float x = (float)this.DefaultPageSettings.Margins.Left;
			float y = (float)this.DefaultPageSettings.Bounds.Top;
			float w = (float)this.DefaultPageSettings.Bounds.Width - this.DefaultPageSettings.Margins.Left - this.DefaultPageSettings.Margins.Right;
			float h = (float) 2 * headerHeight;

			if(pageNo == 0)
			{
				h = (float)(this.DefaultPageSettings.Bounds.Bottom - this.DefaultPageSettings.Bounds.Top);
			}
		
			//setup the alignment
			StringFormat format = new StringFormat();
			format.LineAlignment = StringAlignment.Center;
			format.Alignment = StringAlignment.Center;

			//draw the text
			ev.Graphics.DrawString(text, font, Brushes.Black, new RectangleF(x, y, w, h), format); 

			if(pageNo > 0) //print the footer
			{
				//position the footer; align the footer ; print the footer
				y = (float)(this.DefaultPageSettings.Bounds.Bottom - this.DefaultPageSettings.Margins.Bottom);// - headerHeight - 30;
				h = (float) 2 * footerHeight;
		
				format.LineAlignment = StringAlignment.Far;
				format.Alignment = StringAlignment.Far;

				text = string.Format("Footer Text {0}", pageNo);
				font = new Font(_grid.Font.Name, 10);
				ev.Graphics.DrawString(text, font, Brushes.Black, new RectangleF(x , y, w , h), format); 
			}
			else
				ev.HasMorePages = true;
			pageNo++;
		}
	}



}
